Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 2674)
+++ inc/core/class.dc.trackback.php	(revision 2566)
@@ -482,7 +482,7 @@
 	}
 
-	private static function detectCharset($content)
-	{
-		return mb_detect_encoding($content,
+	private static function detectCharset($string)
+	{
+		return mb_detect_encoding($remote_content,
 				'UTF-8,ISO-8859-1,ISO-8859-2,ISO-8859-3,'.
 				'ISO-8859-4,ISO-8859-5,ISO-8859-6,ISO-8859-7,ISO-8859-8,'.
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2711)
+++ inc/prepend.php	(revision 2735)
@@ -11,7 +11,4 @@
 # -- END LICENSE BLOCK -----------------------------------------
 
-/* Start tick  */
-define('DC_START_TIME',microtime(true));
-
 /* ------------------------------------------------------------------------------------------- */
 #  ClearBricks, DotClear classes auto-loader
@@ -29,55 +26,53 @@
 
 require CLEARBRICKS_PATH.'/_common.php';
-$__autoload['dcCore']        = dirname(__FILE__).'/core/class.dc.core.php';
-$__autoload['dcAuth']        = dirname(__FILE__).'/core/class.dc.auth.php';
-$__autoload['dcBlog']        = dirname(__FILE__).'/core/class.dc.blog.php';
-$__autoload['dcCategories']  = dirname(__FILE__).'/core/class.dc.categories.php';
-$__autoload['dcError']       = dirname(__FILE__).'/core/class.dc.error.php';
-$__autoload['dcMeta']        = dirname(__FILE__).'/core/class.dc.meta.php';
-$__autoload['dcMedia']       = dirname(__FILE__).'/core/class.dc.media.php';
-$__autoload['dcPostMedia']   = dirname(__FILE__).'/core/class.dc.postmedia.php';
-$__autoload['dcModules']     = dirname(__FILE__).'/core/class.dc.modules.php';
-$__autoload['dcPlugins']     = dirname(__FILE__).'/core/class.dc.plugins.php';
-$__autoload['dcThemes']      = dirname(__FILE__).'/core/class.dc.themes.php';
-$__autoload['dcRestServer']  = dirname(__FILE__).'/core/class.dc.rest.php';
-$__autoload['dcNamespace']   = dirname(__FILE__).'/core/class.dc.namespace.php';
-$__autoload['dcSettings']    = dirname(__FILE__).'/core/class.dc.settings.php';
-$__autoload['dcTrackback']   = dirname(__FILE__).'/core/class.dc.trackback.php';
-$__autoload['dcUpdate']      = dirname(__FILE__).'/core/class.dc.update.php';
-$__autoload['dcUtils']       = dirname(__FILE__).'/core/class.dc.utils.php';
-$__autoload['dcXmlRpc']      = dirname(__FILE__).'/core/class.dc.xmlrpc.php';
-$__autoload['dcLog']         = dirname(__FILE__).'/core/class.dc.log.php';
-$__autoload['dcWorkspace']   = dirname(__FILE__).'/core/class.dc.workspace.php';
-$__autoload['dcPrefs']       = dirname(__FILE__).'/core/class.dc.prefs.php';
-$__autoload['dcStore']       = dirname(__FILE__).'/core/class.dc.store.php';
-$__autoload['dcStoreReader'] = dirname(__FILE__).'/core/class.dc.store.reader.php';
-$__autoload['dcStoreParser'] = dirname(__FILE__).'/core/class.dc.store.parser.php';
-$__autoload['dcFavorites']   = dirname(__FILE__).'/admin/class.dc.favorites.php';
-
-$__autoload['rsExtPost']    = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtComment'] = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtDates']   = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-$__autoload['rsExtUser']    = dirname(__FILE__).'/core/class.dc.rs.extensions.php';
-
-$__autoload['dcMenu']            = dirname(__FILE__).'/admin/class.dc.menu.php';
-$__autoload['dcPage']            = dirname(__FILE__).'/admin/lib.dc.page.php';
-$__autoload['adminGenericList']  = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminPostList']     = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminPostMiniList'] = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminCommentList']  = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['adminUserList']     = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['dcPager']           = dirname(__FILE__).'/admin/lib.pager.php';
-$__autoload['dcAdminCombos']     = dirname(__FILE__).'/admin/lib.admincombos.php';
-$__autoload['adminModulesList']  = dirname(__FILE__).'/admin/lib.moduleslist.php';
-$__autoload['adminThemesList']   = dirname(__FILE__).'/admin/lib.moduleslist.php';
-$__autoload['dcThemeConfig']     = dirname(__FILE__).'/admin/lib.themeconfig.php';
-
-$__autoload['dcTemplate']            = dirname(__FILE__).'/public/class.dc.template.php';
-$__autoload['context']               = dirname(__FILE__).'/public/lib.tpl.context.php';
-$__autoload['dcUrlHandlers']         = dirname(__FILE__).'/public/lib.urlhandlers.php';
-$__autoload['dcAdminURL']            = dirname(__FILE__).'/admin/lib.dc.adminurl.php';
-$__autoload['dcPostsActionsPage']    = dirname(__FILE__).'/admin/actions/class.dcactionposts.php';
-$__autoload['dcCommentsActionsPage'] = dirname(__FILE__).'/admin/actions/class.dcactioncomments.php';
-$__autoload['dcActionsPage']         = dirname(__FILE__).'/admin/actions/class.dcaction.php';
+$__autoload['dcCore']				= dirname(__FILE__).'/core/class.dc.core.php';
+$__autoload['dcAuth']				= dirname(__FILE__).'/core/class.dc.auth.php';
+$__autoload['dcBlog']				= dirname(__FILE__).'/core/class.dc.blog.php';
+$__autoload['dcCategories']			= dirname(__FILE__).'/core/class.dc.categories.php';
+$__autoload['dcError']				= dirname(__FILE__).'/core/class.dc.error.php';
+$__autoload['dcMeta']				= dirname(__FILE__).'/core/class.dc.meta.php';
+$__autoload['dcMedia']				= dirname(__FILE__).'/core/class.dc.media.php';
+$__autoload['dcPostMedia']				= dirname(__FILE__).'/core/class.dc.postmedia.php';
+$__autoload['dcModules']				= dirname(__FILE__).'/core/class.dc.modules.php';
+$__autoload['dcPlugins']				= dirname(__FILE__).'/core/class.dc.plugins.php';
+$__autoload['dcThemes']				= dirname(__FILE__).'/core/class.dc.themes.php';
+$__autoload['dcRestServer']			= dirname(__FILE__).'/core/class.dc.rest.php';
+$__autoload['dcNamespace']			= dirname(__FILE__).'/core/class.dc.namespace.php';
+$__autoload['dcSettings']			= dirname(__FILE__).'/core/class.dc.settings.php';
+$__autoload['dcTrackback']			= dirname(__FILE__).'/core/class.dc.trackback.php';
+$__autoload['dcUpdate']				= dirname(__FILE__).'/core/class.dc.update.php';
+$__autoload['dcUtils']				= dirname(__FILE__).'/core/class.dc.utils.php';
+$__autoload['dcXmlRpc']				= dirname(__FILE__).'/core/class.dc.xmlrpc.php';
+$__autoload['dcLog']				= dirname(__FILE__).'/core/class.dc.log.php';
+$__autoload['dcWorkspace']			= dirname(__FILE__).'/core/class.dc.workspace.php';
+$__autoload['dcPrefs']				= dirname(__FILE__).'/core/class.dc.prefs.php';
+$__autoload['dcStore']			= dirname(__FILE__).'/core/class.dc.store.php';
+$__autoload['dcStoreReader']		= dirname(__FILE__).'/core/class.dc.store.reader.php';
+$__autoload['dcStoreParser']		= dirname(__FILE__).'/core/class.dc.store.parser.php';
+$__autoload['dcFavorites']			= dirname(__FILE__).'/admin/class.dc.favorites.php';
+
+$__autoload['rsExtPost']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtComment']			= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtDates']			= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+$__autoload['rsExtUser']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
+
+$__autoload['dcMenu']				= dirname(__FILE__).'/admin/class.dc.menu.php';
+$__autoload['dcPage']				= dirname(__FILE__).'/admin/lib.dc.page.php';
+$__autoload['adminGenericList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminPostList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminPostMiniList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminCommentList']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['adminUserList']			= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['dcPager']		= dirname(__FILE__).'/admin/lib.pager.php';
+$__autoload['dcAdminCombos']			= dirname(__FILE__).'/admin/lib.admincombos.php';
+$__autoload['adminModulesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
+$__autoload['adminThemesList']			= dirname(__FILE__).'/admin/lib.moduleslist.php';
+
+$__autoload['dcTemplate']			= dirname(__FILE__).'/public/class.dc.template.php';
+$__autoload['context']				= dirname(__FILE__).'/public/lib.tpl.context.php';
+$__autoload['dcUrlHandlers']			= dirname(__FILE__).'/public/lib.urlhandlers.php';
+$__autoload['dcPostsActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcactionposts.php';
+$__autoload['dcCommentsActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcactioncomments.php';
+$__autoload['dcActionsPage']			= dirname(__FILE__).'/admin/actions/class.dcaction.php';
 
 # Clearbricks extensions
@@ -140,11 +135,10 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.7-dev');
+define('DC_VERSION','2.6.5');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
 define('DC_L10N_UPDATE_URL','http://services.dotclear.net/dc2.l10n/?version=%s');
-define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets,dcLegacyEditor');
-define('DC_DISTRIB_THEMES','berlin,blueSilence,blowupConfig,customCSS,default,ductile');
-define('DC_DEFAULT_TPLSET','mustek');
+define('DC_DISTRIB_PLUGINS','aboutConfig,akismet,antispam,attachments,blogroll,blowupConfig,dclegacy,fairTrackbacks,importExport,maintenance,pages,pings,simpleMenu,tags,themeEditor,userPref,widgets');
+define('DC_DISTRIB_THEMES','blueSilence,blowupConfig,customCSS,default,ductile');
 
 if (!defined('DC_VENDOR_NAME')) {
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 2666)
+++ inc/public/class.dc.template.php	(revision 2590)
@@ -235,4 +235,102 @@
 	}
 
+	protected function compileFile($file)
+	{
+		$fc = file_get_contents($file);
+
+		$this->compile_stack[] = $file;
+
+		# Remove every PHP tags
+		if ($this->remove_php)
+		{
+			$fc = preg_replace('/<\?(?=php|=|\s).*?\?>/ms','',$fc);
+		}
+
+		# Transform what could be considered as PHP short tags
+		$fc = preg_replace('/(<\?(?!php|=|\s))(.*?)(\?>)/ms',
+		'<?php echo "$1"; ?>$2<?php echo "$3"; ?>',$fc);
+
+		# Remove template comments <!-- #... -->
+		$fc = preg_replace('/(^\s*)?<!-- #(.*?)-->/ms','',$fc);
+
+		# Lexer part : split file into small pieces
+		# each array entry will be either a tag or plain text
+		$blocks = preg_split(
+			'#(<tpl:\w+[^>]*>)|(</tpl:\w+>)|({{tpl:\w+[^}]*}})#msu',$fc,-1,
+			PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
+
+		# Next : build semantic tree from tokens.
+		$rootNode = new tplNode();
+		$node = $rootNode;
+		$errors = array();
+		foreach ($blocks as $id => $block) {
+			$isblock = preg_match('#<tpl:(\w+)(?:(\s+.*?)>|>)|</tpl:(\w+)>|{{tpl:(\w+)(\s(.*?))?}}#ms',$block,$match);
+			if ($isblock == 1) {
+				if (substr($match[0],1,1) == '/') {
+					// Closing tag, check if it matches current opened node
+					$tag = $match[3];
+					if (($node instanceof tplNodeBlock) && $node->getTag() == $tag) {
+						$node->setClosing();
+						$node = $node->getParent();
+					} else {
+						// Closing tag does not match opening tag
+						// Search if it closes a parent tag
+						$search = $node;
+						while($search->getTag() != 'ROOT' && $search->getTag() != $tag) {
+							$search = $search->getParent();
+						}
+						if ($search->getTag() == $tag) {
+							$errors[] = sprintf(
+								__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+								html::escapeHTML($node->getTag()));
+							$search->setClosing();
+							$node = $search->getParent();
+						} else {
+							$errors[]=sprintf(
+								__('Unexpected closing tag </tpl:%s> found.'),
+								$tag);;
+						}
+					}
+				} elseif (substr($match[0],0,1) == '{') {
+					// Value tag
+					$tag = $match[4];
+					$str_attr = '';
+					$attr = array();
+					if (isset($match[6])) {
+						$str_attr = $match[6];
+						$attr = $this->getAttrs($match[6]);
+					}
+					$node->addChild(new tplNodeValue($tag,$attr,$str_attr));
+				} else {
+					// Opening tag, create new node and dive into it
+					$tag = $match[1];
+					$newnode = new tplNodeBlock($tag,isset($match[2])?$this->getAttrs($match[2]):array());
+					$node->addChild($newnode);
+					$node = $newnode;
+				}
+			} else {
+				// Simple text
+				$node->addChild(new tplNodeText($block));
+			}
+		}
+
+		if (($node instanceof tplNodeBlock) && !$node->isClosed()) {
+			$errors[] = sprintf(
+				__('Did not find closing tag for block <tpl:%s>. Content has been ignored.'),
+				html::escapeHTML($node->getTag()));
+		}
+
+		$err = "";
+		if (count($errors) > 0) {
+			$err = "\n\n<!-- \n".
+				__('WARNING: the following errors have been found while parsing template file :').
+				"\n * ".
+				join("\n * ",$errors).
+				"\n -->\n";
+		}
+
+		return $rootNode->compile($this).$err;
+	}
+
 	public function compileBlockNode($tag,$attr,$content)
 	{
@@ -245,5 +343,9 @@
 		$this->core->callBehavior('templateInsideBlock',$this->core,$this->current_tag,$attr,array(&$content));
 
-		$res .= parent::compileBlockNode($this->current_tag,$attr,$content);
+		if (isset($this->blocks[$this->current_tag])) {
+			$res .= call_user_func($this->blocks[$this->current_tag],$attr,$content);
+		} elseif ($this->unknown_block_handler != null) {
+			$res .= call_user_func($this->unknown_block_handler,$this->current_tag,$attr,$content);
+		}
 
 		# --BEHAVIOR-- templateAfterBlock
@@ -261,5 +363,9 @@
 		$res = $this->core->callBehavior('templateBeforeValue',$this->core,$this->current_tag,$attr);
 
-		$res .= parent::compileValueNode($this->current_tag,$attr,$str_attr);
+		if (isset($this->values[$this->current_tag])) {
+			$res .= call_user_func($this->values[$this->current_tag],$attr,ltrim($str_attr));
+		} elseif ($this->unknown_value_handler != null) {
+			$res .= call_user_func($this->unknown_value_handler,$this->current_tag,$attr,$str_attr);
+		}
 
 		# --BEHAVIOR-- templateAfterValue
@@ -267,4 +373,18 @@
 
 		return $res;
+	}
+
+	public function setUnknownValueHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_value_handler = $callback;
+		}
+	}
+
+	public function setUnknownBlockHandler($callback)
+	{
+		if (is_callable($callback)) {
+			$this->unknown_block_handler = $callback;
+		}
 	}
 
@@ -276,5 +396,4 @@
 		$p[3] = '0';	# lower_case
 		$p[4] = '0';	# upper_case or capitalize
-		$p[5] = '0';    # encode_url
 
 		$p[0] = (integer) (!empty($attr['encode_xml']) || !empty($attr['encode_html']));
@@ -288,5 +407,4 @@
 		$p[4] = (integer) !empty($attr['upper_case']);
 		$p[4] = (!empty($attr['capitalize']) ? 2 : $p[4]);
-		$p[5] = (integer) !empty($attr['encode_url']);
 
 		return "context::global_filter(%s,".implode(",",$p).",'".addslashes($this->current_tag)."')";
@@ -387,33 +505,4 @@
 	}
 
-	public function displayCounter($variable,$values,$attr,$count_only_by_default=false) {
-		if (isset($attr['count_only'])) {
-			$count_only=($attr['count_only']==1);
-		} else {
-			$count_only = $count_only_by_default;
-		}
-		if ($count_only) {
-			return "<?php echo ".$variable."; ?>";
-		} else {
-			$v=$values;
-			if (isset($attr['none'])) {
-				$v['none'] = addslashes($attr['none']);
-			}
-			if (isset($attr['one'])) {
-				$v['one'] = addslashes($attr['one']);
-			}
-			if (isset($attr['more'])) {
-				$v['more'] = addslashes($attr['more']);
-			}
-			return
-				"<?php if (".$variable." == 0) {\n".
-				"  printf(__('".$v['none']."'),".$variable.");\n".
-				"} elseif (".$variable." == 1) {\n".
-				"  printf(__('".$v['one']."'),".$variable.");\n".
-				"} else {\n".
-				"  printf(__('".$v['more']."'),".$variable.");\n".
-				"} ?>";
-		}
-	}
 	/* TEMPLATE FUNCTIONS
 	------------------------------------------------------- */
@@ -576,14 +665,5 @@
 	{
 		$f = $this->getFilters($attr);
-		return $this->displayCounter(
-			sprintf($f,'$_ctx->archives->nb_post'),
-			array(
-				'none' => 'no archive',
-				'one'  => 'one archive',
-				'more' => '%d archives'
-			),
-			$attr,
-			true
-		);
+		return '<?php echo '.sprintf($f,'$_ctx->archives->nb_post').'; ?>';
 	}
 
@@ -1061,14 +1141,5 @@
 	{
 		$f = $this->getFilters($attr);
-		return $this->displayCounter(
-			sprintf($f,'$_ctx->categories->nb_post'),
-			array(
-				'none' => 'No post',
-				'one'  => 'One post',
-				'more' => '%d posts'
-			),
-			$attr,
-			true
-		);
+		return '<?php echo '.sprintf($f,'$_ctx->categories->nb_post').'; ?>';
 	}
 
@@ -1102,18 +1173,13 @@
 
 		if ($lastn != 0) {
-			// Set limit (aka nb of entries needed)
 			if ($lastn > 0) {
-				// nb of entries per page specified in template -> regular pagination
 				$p .= "\$params['limit'] = ".$lastn.";\n";
 			} else {
-				// nb of entries per page not specified -> use ctx settings
-				$p .= "\$params['limit'] = (\$_page_number == 1 ? \$_ctx->nb_entry_first_page : \$_ctx->nb_entry_per_page);\n";
+				$p .= "\$params['limit'] = \$_ctx->nb_entry_per_page;\n";
 			}
-			// Set offset (aka index of first entry)
+
 			if (!isset($attr['ignore_pagination']) || $attr['ignore_pagination'] == "0") {
-				// standard pagination, set offset
-				$p .= "\$params['limit'] = array((\$_page_number == 1 ? 0 : (\$_page_number - 2) * \$_ctx->nb_entry_per_page + \$_ctx->nb_entry_first_page),\$params['limit']);\n";
+				$p .= "\$params['limit'] = array(((\$_page_number-1)*\$params['limit']),\$params['limit']);\n";
 			} else {
-				// no pagination, get all posts from 0 to limit
 				$p .= "\$params['limit'] = array(0, \$params['limit']);\n";
 			}
@@ -1769,7 +1835,4 @@
 	}
 
-
-
-
 	/*dtd
 	<!ELEMENT tpl:EntryCommentCount - O -- Number of comments for entry -->
@@ -1783,4 +1846,18 @@
 	public function EntryCommentCount($attr)
 	{
+		$none = 'no comment';
+		$one = 'one comment';
+		$more = '%d comments';
+
+		if (isset($attr['none'])) {
+			$none = addslashes($attr['none']);
+		}
+		if (isset($attr['one'])) {
+			$one = addslashes($attr['one']);
+		}
+		if (isset($attr['more'])) {
+			$more = addslashes($attr['more']);
+		}
+
 		if (empty($attr['count_all'])) {
 			$operation = '$_ctx->posts->nb_comment';
@@ -1789,14 +1866,12 @@
 		}
 
-		return $this->displayCounter(
-			$operation,
-			array(
-				'none' => 'no comments',
-				'one'  => 'one comment',
-				'more' => '%d comments'
-				),
-			$attr,
-			false
-		);
+		return
+		"<?php if (".$operation." == 0) {\n".
+		"  printf(__('".$none."'),".$operation.");\n".
+		"} elseif (".$operation." == 1) {\n".
+		"  printf(__('".$one."'),".$operation.");\n".
+		"} else {\n".
+		"  printf(__('".$more."'),".$operation.");\n".
+		"} ?>";
 	}
 
@@ -1811,14 +1886,26 @@
 	public function EntryPingCount($attr)
 	{
-		return $this->displayCounter(
-			'$_ctx->posts->nb_trackback',
-			array(
-				'none' => 'no trackback',
-				'one'  => 'one trackback',
-				'more' => '%d trackbacks'
-				),
-			$attr,
-			false
-		);
+		$none = 'no trackback';
+		$one = 'one trackback';
+		$more = '%d trackbacks';
+
+		if (isset($attr['none'])) {
+			$none = addslashes($attr['none']);
+		}
+		if (isset($attr['one'])) {
+			$one = addslashes($attr['one']);
+		}
+		if (isset($attr['more'])) {
+			$more = addslashes($attr['more']);
+		}
+
+		return
+		"<?php if (\$_ctx->posts->nb_trackback == 0) {\n".
+		"  printf(__('".$none."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} elseif (\$_ctx->posts->nb_trackback == 1) {\n".
+		"  printf(__('".$one."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} else {\n".
+		"  printf(__('".$more."'),(integer) \$_ctx->posts->nb_trackback);\n".
+		"} ?>";
 	}
 
Index: inc/public/default-templates/rss2.xsl
===================================================================
--- inc/public/default-templates/rss2.xsl	(revision 2566)
+++ inc/public/default-templates/rss2.xsl	(revision 2566)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0"
+xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+xmlns:content="http://purl.org/rss/1.0/modules/content/"
+xmlns="http://www.w3.org/1999/xhtml">
+
+<xsl:output method="html"/>
+
+<xsl:template match="/">
+<html>
+  <head>
+    <title>{{tpl:lang Subscribe to}} <xsl:value-of select="/rss/channel/title"/></title>
+    <style type="text/css">
+    <![CDATA[
+    body {
+      font: 80% Verdana,Arial,sans-serif;
+      margin: 20px 0;
+      padding: 0 0;
+      background: #fff;
+      color: #000;
+    }
+    a { color: #039; }
+    h1, h2 { font-family: Arial,sans-serif; }
+    h1 { font-size: 160%; margin: 0; }
+    h2 { font-size: 140%; font-weight: bold; margin: 0.5em 0 0.2em 0; }
+    h2 a { text-decoration: none; }
+    p { margin: 0 0 0.5em 0; }
+    #page {
+      margin: 0 80px;
+    }
+    #top {
+      background: #036;
+      padding : 1em;
+      color: #fff;
+    }
+    #top a {
+      color: #fff;
+      text-decoration: none;
+    }
+    #what {
+      padding: 1em;
+      background: #eee;
+      border-bottom: 1px solid #000;
+      font-size: 80%;
+    }
+    #what p {
+      margin: 0 0 0.5em 0;
+    }
+    #footer {
+      border-top: 1px solid #000;
+    }
+    #items {
+      background: #fff;
+      color: inherit;
+    }
+    #items div {
+      margin: 0 0 1em 0;
+    }
+    ]]>
+    </style>
+    <script type="text/javascript"><![CDATA[
+    window.onload = function() {
+      document.getElementById('feedurl').value = window.location.href;
+
+      // Ugly but works ;)
+      var c = document.getElementsByTagName('div');
+      var t = '';
+      for (var i=0; c.length-i != 0; i++) {
+        if (c[i].className == 'item-content') {
+          if (c[i].textContent) {
+            t = c[i].textContent;
+          } else if (c[i].innerText) {
+            t = c[i].innerText;
+          } else {
+            t = '';
+          }
+
+          if (t) { c[i].innerHTML = t; }
+        }
+      }
+    };
+    ]]></script>
+  </head>
+  <body>
+    <div id="page">
+      <div id="top">
+        <h1><a href="{/rss/channel/link}"><xsl:value-of select="/rss/channel/title"/></a></h1>
+        <p><xsl:value-of select="/rss/channel/description"/></p>
+      </div>
+      <div id="what">
+      <h3>{{tpl:lang What is an RSS feed?}}</h3>
+      <p>{{tpl:lang RSS feed is a free blog summary. It provides content
+      (either posts or comments) or  summaries of content, together with links
+      to the full versions, and other metadata. The last published items may
+      then be read by your favorite RSS
+      <a href="http://en.wikipedia.org/wiki/Aggregator">aggregator</a>.}}</p>
+      <h3>{{tpl:lang Subscribe}}</h3>
+      <p>{{tpl:lang Simply copy the following URL into your aggregator:}}</p>
+      <p><input type="text" size="60" value="" id="feedurl" /></p>
+      </div>
+      <div id="items">
+        <xsl:apply-templates select="//item"/>
+      </div>
+      <div id="footer">
+        <p><xsl:value-of select="/rss/channel/copyright"/></p>
+      </div>
+    </div>
+  </body>
+</html>
+</xsl:template>
+
+<!-- Item template -->
+<xsl:template match="item">
+  <div>
+    <h2><a href="{link}"><xsl:value-of select="title"/></a></h2>
+    <div class="item-content"><xsl:value-of select="description" /></div>
+  </div>
+</xsl:template>
+
+</xsl:stylesheet>
Index: inc/public/lib.tpl.context.php
===================================================================
--- inc/public/lib.tpl.context.php	(revision 2676)
+++ inc/public/lib.tpl.context.php	(revision 2566)
@@ -100,51 +100,44 @@
 
 
-        # Static methods
-        public static function global_filter($str,
-        $encode_xml, $remove_html, $cut_string, $lower_case, $upper_case ,$encode_url ,$tag='')
-        {
-                $args = func_get_args();
-                array_pop($args);
-                $args[0] =& $str;
-
-                # --BEHAVIOR-- publicBeforeContentFilter
-                $res = $GLOBALS['core']->callBehavior('publicBeforeContentFilter',$GLOBALS['core'],$tag,$args);
-
-                if ($remove_html) {
-                        $str = self::remove_html($str);
-                        $str = preg_replace('/\s+/',' ',$str);
-                }
-
-                if ($encode_xml) {
-                        $str = self::encode_xml($str);
-                }
-
-                if ($cut_string) {
-                        $str = self::cut_string($str,(integer) $cut_string);
-                }
-
-                if ($lower_case) {
-                        $str = self::lower_case($str);
-                } elseif ($upper_case) {
-                        if ($upper_case == 2) {
-                                $str = self::capitalize($str);
-                        } else {
-                                $str = self::upper_case($str);
-                        }
-                }
-                if ($encode_url) {
-                        $str = self::encode_url($str);
-                }
-
-                # --BEHAVIOR-- publicAfterContentFilter
-                $res = $GLOBALS['core']->callBehavior('publicAfterContentFilter',$GLOBALS['core'],$tag,$args);
-
-                return $str;
-        }
-
-        public static function encode_url($str)
-        {
-                return urlencode($str);
-        }
+	# Static methods
+	public static function global_filter($str,
+	$encode_xml, $remove_html, $cut_string, $lower_case, $upper_case ,$tag='')
+	{
+		$args = func_get_args();
+		array_pop($args);
+		$args[0] =& $str;
+
+		# --BEHAVIOR-- publicBeforeContentFilter
+		$res = $GLOBALS['core']->callBehavior('publicBeforeContentFilter',$GLOBALS['core'],$tag,$args);
+
+		if ($remove_html) {
+			$str = self::remove_html($str);
+			$str = preg_replace('/\s+/',' ',$str);
+		}
+
+		if ($encode_xml) {
+			$str = self::encode_xml($str);
+		}
+
+		if ($cut_string) {
+			$str = self::cut_string($str,(integer) $cut_string);
+		}
+
+		if ($lower_case) {
+			$str = self::lower_case($str);
+		} elseif ($upper_case) {
+			if ($upper_case == 2) {
+				$str = self::capitalize($str);
+			} else {
+				$str = self::upper_case($str);
+			}
+		}
+
+		# --BEHAVIOR-- publicAfterContentFilter
+		$res = $GLOBALS['core']->callBehavior('publicAfterContentFilter',$GLOBALS['core'],$tag,$args);
+
+		return $str;
+	}
+
 
 	public static function cut_string($str,$l)
@@ -213,5 +206,7 @@
 
 		$nb_posts = $_ctx->pagination->f(0);
-		$nb_pages = ceil(($nb_posts - $_ctx->nb_entry_first_page) / $_ctx->nb_entry_per_page + 1);
+		$nb_per_page = $_ctx->post_params['limit'][1];
+
+		$nb_pages = ceil($nb_posts/$nb_per_page);
 
 		return $nb_pages;
@@ -311,7 +306,4 @@
 		if (isset($GLOBALS['__theme'])) {
 			$path[] = $GLOBALS['__theme'];
-			if (isset($GLOBALS['__parent_theme'])) {
-				$path[] = $GLOBALS['__parent_theme'];
-			}
 		}
 		$path[] = 'default';
@@ -509,8 +501,4 @@
 			{
 				$res = '.'.$base.'_'.$size.'.jpg';
-			}
-			elseif ($size != 'o' && file_exists($root.'/'.$info['dirname'].'/.'.$base.'_'.$size.'.png'))
-			{
-				$res = '.'.$base.'_'.$size.'.png';
 			}
 			else
Index: inc/public/lib.urlhandlers.php
===================================================================
--- inc/public/lib.urlhandlers.php	(revision 2635)
+++ inc/public/lib.urlhandlers.php	(revision 2634)
@@ -86,7 +86,4 @@
 			$_ctx->nb_entry_per_page = $core->blog->settings->system->nb_post_per_page;
 		}
-		if ($_ctx->nb_entry_first_page === null) {
-			$_ctx->nb_entry_first_page = $_ctx->nb_entry_per_page;
-		}
 
 		$tpl_file = $core->tpl->getFilePath($tpl);
@@ -191,5 +188,4 @@
 		else
 		{
-			$_ctx =& $GLOBALS['_ctx'];
 			$core =& $GLOBALS['core'];
 
@@ -200,7 +196,4 @@
 
 			if (empty($_GET['q'])) {
-				if ($core->blog->settings->system->nb_post_for_home !== null) {
-					$_ctx->nb_entry_first_page = $core->blog->settings->system->nb_post_for_home;
-				}
 				self::serveDocument('home.html');
 				$core->blog->publishScheduledEntries();
@@ -423,16 +416,10 @@
 					if ($content != '')
 					{
-						# --BEHAVIOR-- publicBeforeCommentTransform
-						$buffer = $core->callBehavior('publicBeforeCommentTransform',$content);
-						if ($buffer != '') {
-							$content = $buffer;
+						if ($core->blog->settings->system->wiki_comments) {
+							$core->initWikiComment();
 						} else {
-							if ($core->blog->settings->system->wiki_comments) {
-								$core->initWikiComment();
-							} else {
-								$core->initWikiSimpleComment();
-							}
-							$content = $core->wikiTransform($content);
+							$core->initWikiSimpleComment();
 						}
+						$content = $core->wikiTransform($content);
 						$content = $core->HTMLfilter($content);
 					}
Index: inc/public/prepend.php
===================================================================
--- inc/public/prepend.php	(revision 2567)
+++ inc/public/prepend.php	(revision 2566)
@@ -134,15 +134,10 @@
 	$__theme_tpl_path[] = $core->blog->themes_path.'/'.$__parent_theme.'/tpl';
 }
-$tplset = $core->themes->moduleInfo($core->blog->settings->system->theme,'tplset');
-if (!empty($tplset) && is_dir(dirname(__FILE__).'/default-templates/'.$tplset)) {
-	$core->tpl->setPath(
-		$__theme_tpl_path,
-		dirname(__FILE__).'/default-templates/'.$tplset,
-		$core->tpl->getPath());
-} else {
-	$core->tpl->setPath(
-		$__theme_tpl_path,
-		$core->tpl->getPath());
-}
+
+$core->tpl->setPath(
+	$__theme_tpl_path,
+	dirname(__FILE__).'/default-templates',
+	$core->tpl->getPath());
+
 $core->url->mode = $core->blog->settings->system->url_scan;
 
